package
{
	import flash.display.Sprite;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.filesystem.FileMode;
    import flash.filesystem.FileStream;
    import flash.filesystem.File;
    import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.utils.ByteArray;
	
	import com.nativeExtensions.saf.Document;
	import com.nativeExtensions.saf.DocumentEvent;
	
    public class Main extends Sprite
	{
        private var textField:TextField = new TextField();
		private var document:Document;

        public function Main()
		{		
			this.addEventListener(Event.ADDED_TO_STAGE, addedToStageHandler);
        }
		
		private function addedToStageHandler(event:Event):void
        {
            this.removeEventListener(Event.ADDED_TO_STAGE, addedToStageHandler);
			stage.align = StageAlign.TOP_LEFT;
			stage.scaleMode = StageScaleMode.NO_SCALE;
			
            textField.border = true;
			textField.type = "input";
			textField.wordWrap = true;
			textField.multiline = true;
			textField.width = 800;
			textField.height = 800;

            var format:TextFormat = new TextFormat();
            format.size = 30;

            textField.defaultTextFormat = format;
            this.addChild(textField);
			
			var sprite:Sprite = new Sprite();
			sprite.graphics.beginFill(0x0000FF);
			sprite.graphics.drawRect( 0, 0, 200, 200);
			sprite.graphics.endFill();
			sprite.y = textField.height + 20;
			sprite.addEventListener(MouseEvent.CLICK, mouseClickReadHandler);
			this.addChild( sprite );
			var textField1:TextField = new TextField();
			textField1.defaultTextFormat = format;
			textField1.mouseEnabled = false;
			textField1.text = "read";
			textField1.y = sprite.y;
			this.addChild( textField1 );
			
			var sprite2:Sprite = new Sprite();
			sprite2.graphics.beginFill(0x0000FF);
			sprite2.graphics.drawRect( 0, 0, 200, 200);
			sprite2.graphics.endFill();
			sprite2.x = sprite.x + sprite.width + 20;
			sprite2.y = sprite.y;
			sprite2.addEventListener(MouseEvent.CLICK, mouseClickEditHandler);
			this.addChild( sprite2 );
			var textField2:TextField = new TextField();
			textField2.defaultTextFormat = format;
			textField2.mouseEnabled = false;
			textField2.text = "edit";
			textField2.x = sprite2.x;
			textField2.y = sprite2.y;
			this.addChild( textField2 );
			
			document = new Document();
			document.addEventListener(DocumentEvent.READ, onRead);
			document.addEventListener(DocumentEvent.EDIT, onEdit);
			document.addEventListener(DocumentEvent.CANCEL, onCancel);
		}
		
		private function mouseClickReadHandler(event : MouseEvent) : void
		{
			document.getUri( "public.data" );
		}
		
		private function mouseClickEditHandler(event : MouseEvent) : void
		{
			var file:File = File.applicationDirectory.resolvePath( "image.jpg" );
			document.uri = file.nativePath;
			document.editFromUriAsync();
		}
		
		private function onRead(event:DocumentEvent):void
		{
			trace( event.file.url );
			
			var file:File = new File( event.file.url );
			var fileStream:FileStream = new FileStream();
			fileStream.open(file, FileMode.READ);
			var bytes:ByteArray = new ByteArray();
			fileStream.readBytes(bytes, 0, fileStream.bytesAvailable); 
			fileStream.close();
			trace( bytes.length );
		}
		
		private function onEdit(event:DocumentEvent):void
		{
			trace( event.file.url );
		}
		
		private function onCancel(event:DocumentEvent):void
		{
			trace( event.isImport );
		}
    }
}